#
# Copyright (c) 2001 - 2002, VIA Technologies, Inc. 
#
# All rights reserved.
#

VMNS_DEBUG	=	0
CC			=	gcc

ARCH 		:= $(shell uname -m | sed 's/i.86/i386/')

DEFINES     =   -DMODULE -D__KERNEL__ -DLINUX -DEXPORT_SYMTAB -D__NO_VERSION__

KERNELDIRS	:=  /lib/modules/$(shell uname -r)/build \
        		/usr/src/linux-$(shell uname -r) \
		        /usr/src/linux-$(shell uname -r | sed 's/-.*//') \
		        /usr/src/kernel-headers-$(shell uname -r) \
		        /usr/src/kernel-source-$(shell uname -r) \
		        /usr/src/linux-$(shell uname -r | sed 's/\([0-9]*\.[0-9]*\)\..*/\1/') \
		        /usr/src/linux

KERNELDIRS	:=  $(foreach dir, $(KERNELDIRS), $(shell [ -e $(dir)/include/linux ] && echo $(dir)))

KERNELDIR	:=	$(firstword $(KERNELDIRS))
#KERNELDIR	:=	/usr/src/linux-2.2.0
KERNVERFILE	:= $(KERNELDIR)/include/linux/version.h

KERNCFGFILE := $(KERNELDIR)/include/linux/config.h

KERNVER := $(shell $(CC) $(CFLAGS) -E -dM $(KERNVERFILE) | grep UTS_RELEASE |\
          awk '{ print $$3 }' | sed 's/\"//g')

INCLUDE		=	-I. -I$(KERNELDIR)/include -I../include


ifneq (,$(wildcard /lib/modules/$(KERNVER)/kernel))
  MOD_DIR := /lib/modules/$(KERNVER)/kernel/drivers/net
else
  MOD_DIR := /lib/modules/$(KERNVER)/net
endif

SMP := $(shell $(CC) $(CFLAGS) -E -dM $(KERNCFGFILE) | \
         grep CONFIG_SMP | awk '{ print $$3 }')

MODVERSIONS := $(shell $(CC) -E -dM $(KERNCFGFILE) | grep CONFIG_MODVERSIONS \
				| awk '{ print $$3 }')

ifeq ($(MODVERSIONS), 1)
	DEFINES +=	-DMODVERSIONS -include $(KERNELDIR)/include/linux/modversions.h
endif

ifneq ($(SMP),1)
  SMP := 0
endif

ifeq ($(SMP), 1)
  DEFINES += -D__SMP__
endif

ifeq ($(VMNS_DEBUG),1) 
  DEFINES += -DVMNS_DEBUG
endif
CFLAGS += -pipe -O3 -Wall -Wstrict-prototypes $(DEFINES) $(INCLUDE)
