
#include <linux/config.h>
#include <linux/version.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <asm/uaccess.h>
#include "debug.h"

extern int debug;

void vmns_panic(const char * fmt, ...)
{
	static char buf[1024];	  
	va_list args;
	va_start(args, fmt);
	vsprintf(buf, fmt, args);
	va_end(args);
	panic(buf);
}

int vmns_printk(int level,const char* fmt, ...) {
//	char 	buf[1024]=KERN_CRIT"";
	
	static  char 	buf[1024]="";
	char* 	ptr=buf;
        strcpy(buf,KERN_INFO"vmns: ");	
	if (level<=debug) {
		va_list args;		
		while (*ptr++!=0) 
			do {} while(0);
		--ptr;
		va_start(args, fmt);
		vsprintf(ptr,fmt,args);
		va_end(args);
		return printk(buf);
	}
	return 0;
}
