/*
	Author	:	Shing
	Date	:   2001/04/23
*/
#ifndef VMNS_DEBUG_H
#define VMNS_DEBUG_H

//#include <linux/kernel.h>
#define VMNS_ERROR(fmt, args...) \
	printk(KERN_ERR   "%s: " fmt, __FUNCTION__ , ## args)

#ifdef VMNS_DEBUG

#	define VMNS_DBG(fmt, args...) printk(KERN_DEBUG "%s: " fmt, __FUNCTION__ , ## args)
#	define ASSERT(x) {\
			if (!(x)) vmns_panic("Assertion %s failed: file %s line %d\n", #x , __FILE__,__LINE__);\
			}
void vmns_panic(const char*,...);
#else

#	define ASSERT(x)
#	define VMNS_DBG(fmt, args...)          

#endif

#define	LOG_LEVEL_NONE		0
#define	LOG_LEVEL_INFO		1
#define LOG_LEVEL_VERBOSE	2
#define LOG_LEVEL_DEBUG		3

int vmns_printk(int level,const char*, ...); 

#endif
