/*
 Copyright (c) 1999-2001, VIA Techonolgies, Inc.

 All rights reserved.
 
*/
#ifndef	KCOMPAT_H
#define	KCOMPAT_H


#include <linux/version.h>
#include <linux/netdevice.h>
#include <asm/io.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,2,0)
#error Linux kernel version wrong
#endif

#if   LINUX_VERSION_CODE < KERNEL_VERSION(2,3,43)
#define dev_kfree_skb_irq(skb) dev_kfree_skb(skb)
#define dev_get_by_name(name) dev_get(name)
#endif


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,3,43)
#define netif_start_queue(dev)   clear_bit  (0, &(dev)->tbusy)
#define netif_stop_queue(dev)    set_bit    (0, &(dev)->tbusy)
#define netif_wake_queue(dev)    { clear_bit(0, &(dev)->tbusy); \
                                                mark_bh(NET_BH); }
#define netif_running(dev)       test_bit(0, &(dev)->start)
#define netif_queue_stopped(dev) test_bit(0, &(dev)->tbusy)
#elif LINUX_VERSION_CODE < KERNEL_VERSION(2,3,47)
#define netif_running(dev)       test_bit(LINK_STATE_START, &(dev)->state)
#define netif_queue_stopped(dev) test_bit(LINK_STATE_XOFF,  &(dev)->state)
#endif

#if   LINUX_VERSION_CODE < KERNEL_VERSION(2,4,0)
#define kern_sp_lock_init(lock)
#define kern_sp_lock(lock)
#define kern_sp_unlock(lock)
#define kern_sp_lock_irq(lock,flags)
#define kern_sp_unlock_irq(lock,flags)
#define kern_sp_lock_bh(lock)			start_bh_atomic()
#define kern_sp_unlock_bh(lock)		end_bh_atomic()
#else
#define kern_sp_lock_init(lock)		spin_lock_init(lock)
#define kern_sp_lock(lock)				spin_lock(lock)
#define kern_sp_unlock(lock)			spin_unlock(lock)
#define kern_sp_lock_irq(lock,flags)	spin_lock_irqsave(lock,flags)
#define kern_sp_unlock_irq(lock,flags)	spin_unlock_irqrestore(lock,flags)
#define kern_sp_lock_bh(lock)			spin_lock_bh(lock)
#define kern_sp_unlock_bh(lock)		spin_unlock_bh(lock)
#endif


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,3,13)
#define module_init(fn) int  init_module   (void) { return fn(); }
#define module_exit(fn) void cleanup_module(void) { return fn(); }
#endif


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,3,14) 
#define net_device	device
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,0)
#define LINUX_KERNEL_22X
#undef  LINUX_KERNEL_24X
#endif


#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,0)
#undef  LINUX_KERNEL_22X
#define LINUX_KERNEL_24X
#endif


#endif
