#ifndef _CONFIG_H
#define _CONFIG_H

#ifdef __KERNEL__
#include <linux/config.h>
#endif

typedef unsigned char	U8,		*PU8;
typedef unsigned short	U16,	*PU16;
typedef unsigned int	U32,	*PU32;
typedef unsigned char	UCHAR,	*PUCHAR;
typedef unsigned short	UINT16,	*PUINT16;
typedef unsigned char	UINT8,	*PUINT8;
typedef unsigned int	UINT32,	*PUINT32;
typedef unsigned int	UINT, 	*PUINT;
typedef unsigned char	BYTE,	*PBYTE;
typedef unsigned int	BOOL,	*PBOOL;
typedef unsigned short  WORD,	*PWORD;
typedef unsigned short	USHORT, *PUSHORT;
typedef unsigned int	DWORD,	*PDWORD;
typedef unsigned long	ULONG,	*PULONG;

typedef
struct _version {
	UINT8	major;
	UINT8	minor;
	UINT8	build;
} version_t, *pversion_t;

typedef struct _mac_addr {
	UCHAR	addr[6];
} MAC_ADDR, *PMAC_ADDR;

#ifndef	FALSE
#define	FALSE	(0)
#endif

#ifndef	TRUE
#define	TRUE	(~(FALSE))
#endif

#ifndef NULL
#define NULL	(0)
#endif

#ifndef ULONG_MAX
#define	ULONG_MAX		((ULONG) -1)
#endif

#define	ETH_ALEN		6

#define	TIME_INTERVAL	10*HZ		//Time interval for flows

#define VID_TABLE_SIZE		64
#define MCAST_TABLE_SIZE	64
#define MCAM_SIZE			32
#define VCAM_SIZE			32

#   if !defined(__constant_htons)
#       define __constant_htons(x) \
        ((unsigned short int)((((unsigned short int)(x) & 0x00ff) << 8) | \
                             (((unsigned short int)(x) & 0xff00) >> 8)))
#   endif

#endif
