#!/usr/bin/perl
use vmns_redhat;

#
# Show banner
#
sub banner {
	my $p=shift @_;
	my $star='*' x 60;
	print <<EOF;

$star
$p
$star

EOF
}

#
# Show Help
#
sub help_menu {
print<<EOF;


    VIA Management Network Service is a Linux Kernel Moudle which you may 
used to setup new advanced functions of VT6105M chip. 

	VMNS must running on new VIA network adapter's Linux driver Ver.4.0.4 or 
latter, in order to support this VMNS service. 

EOF
	&prompt("Press enter key to continue ......");
}

#Main menu
sub main_menu {
	&banner("VIA Management Network Sevice Setup Program V.1.0");
	print <<EOF;
0. Introduction
1. Install VMNS
2. Setup VMNS configuration
3. Remove VMNS configuration
4. Uninstall VMNS
5. Quit
EOF
	print "Please enter your choice [2]:";
}

sub load_module {

	print "\nActivating all network interfaces.\n\n";
	chdir $IFCFGDIR;

	my @interfaces=`\\ls ifcfg* | \\grep -v '(ifcfg-lo|:)' | \\grep -v 'ifcfg-ippp[0-9]+$' | \\grep 'ifcfg-[a-z0-9]+$' | \\sed 's/^ifcfg-//g'`;

	foreach (@interfaces)
	{
	 	`/sbin/ifconfig $_ 2>&1 > /dev/null`;
	}

	print "\n\nWould you like to automatically bring all network interfaces down?";
	$auto = (options("y", "n") eq "y");

	foreach (`\\cat /proc/net/dev`)
	{
		if (s/^\ *(.*):.*$/\1/)
		{
			chomp;
			unless ($auto)
			{
				print "Remove network interface $_? ";
				$res  = (options("y", "n") eq "y");
			}
			`/sbin/ifconfig $_ down 2>&1 > /dev/null` if ($res || $auto);
		}
	}

	foreach (@DRVMODS) {
		&remove_module($_);
	}	

	`/sbin/rmmod vmns 2>&1 > /dev/null`;
	`/sbin/rmmod linuxfet 2>&1 >/dev/null`;

	system "/sbin/insmod linuxfet";
	system "/sbin/insmod vmns";

	&get_vmns_adapters();

	open (OUT,">>$CONF");
	print OUT "#NEXT LINES INSERTED BY VMNS SETUP PROGRAM\n";
	foreach (@Adapters) {
		print OUT "alias $_ linuxfet\n";
	}
	close(OUT);	

	sleep 3;
	chdir ($CWD);
	`rm -f ifcfg-*`;
}

sub remove_module
{
	 my($mod_name) = @_;
	 my(@file);
	 `rmmod $mod_name 2>&1 > /dev/null`;
	 @file = `\\cat $CONF`;
	 open (OUT, ">$CONF");
	 foreach $line (@file)
	 {
		  if ($line=~/^[^#]*\b$mod_name\b/)
		  {
				print OUT "#NEXT LINE COMMENTED OUT BY VMNS SETUP PROGRAM\n";
				print OUT "#$line\n";
		  }
		  else
		  {
				print OUT $line;
		  }
	 }
	 close(OUT);
}

sub get_vmns_adapters {
	my $i=0;
	chdir ($CWD);
	open IN, "../../bin/GetAdapters|";
	while (<IN>) {
		($name, $id)=split(/ /);
		if ($id >= 0x90) {
			$Adapters[$i++]=$name;
		}		
	}
	close IN;
	
	if ($i==0)  {
		print "No VIA VT6105M Rhine III Management Adapter found,\n";
		print "or driver version error!\n";
		exit;
	}

	return $i;
}

sub setup {

	my %Agg=();
	my @adaps=();
	my %Aggs=();
	my %vadap=();
    my %vlans=();
	my $i;
	my $AggNum=0;
	my @vmns_script=();

	chdir ($CWD);

	&get_vmns_adapters();

	push @vmns_script,"CONNECT VMNS\n";

	WW: while (@Adapters) {

		print "\nPlease enter the name of aggregator you want to create:\n";
		print "Ex. agg0, agg1, agg2\n";
		print "\nEnter aggregator name, or <ENTER> to end: ";
		$Agg{name}=<STDIN>;
		chomp($Agg{name});	
		return 0 if (($Agg{name} eq "") && ($AggNum==0));
		$AggNum++;
		last WW if ($Agg{name} eq "");

		if ($Aggs{$Agg{name}}) {
			print "The name of aggregator must be unique, please enter again\n";
			next WW;
		}

		$Aggs{$Agg{name}}=1;

		print "\nEnter aggregator $Agg{name}'s running mode:\n";
		print "0.NONE\n";
		print "1.LBFO\n";
		print "\nSelect (0-1):";

		$Agg{Mode}=<STDIN>;
		chomp($Agg{Mode});

		print "\nDo you want to enable vlan on aggregator $Agg{name} ";
		$Agg{vlan}=options("y", "n");
		
		print "\nYou may use up to at most 4 adapters to attach to a aggregator\n";

		$i=1; 
		W: while ($i <=8) {
			do {
				print "\nSelect ${i}th adapter you want to attach to this aggregator: \n";
				print "0. done\n";
				for ($j=0;$j<@Adapters;$j++) {
					print $j+1 . "." . " $Adapters[$j]\n";
				}
				print "Enter number (0-". ($#Adapters+1) . "): ";
				$index=<STDIN>;
				chomp($index);
				if ($index eq 0) {
					if ($i==1) {
						print "You must attach at least one adapter to aggregator\n";
						next W;
					}
					last W;
				}
			};
			push (@adaps, $Adapters[$index-1]);
			splice (@Adapters, $index-1,1);		
			$i++;
			last W if ($Agg{Mode}==0);
		}

		print "\nSetting up virtual adapters.\n";

		$i=0;

		W2: while ($i<32) {

			print "\nPlease enter the name of virtual adapter, or <ENTER> to end: ";
			$vadap{name}=<STDIN>;

			if ($vadap{name} eq "\n") {
				if ($i==0) {
					print "You need to set up at least one virtual adapter\n";
					next W2;
				} 
				else {
					last W2;
				}
			};
			$i++;
			if ($vadaps{$vadap{name}}) {
				print "The name of virutal adapter must be unique, please enter again\n";
				next W2;
			}
			$vadaps{$vadap{name}}=1;
			chomp($vadap{name});

			if ($Agg{vlan} eq "y") {
				$vid=0;
				AGA2: {
					do {
						print "Enter VLAN ID of virtual adapter (1-4094): ";
						$vid=<STDIN>;
						chomp($vid);
					} while ($vid<1|| $vid >4094);

					if ($vids{$vid}) {
						print "VLAN ID must be unique. please enter again.\n";
						goto AGA2;
					}

					$vids{$vid}=1;
				}
				$vadap{vid}=$vid;
				chomp($vadap{vid});
				$vlans{$vadap{name}}=$vadap{vid};
			} else {
				$vlans{$vadap{name}}=0;
			}

			print "Enter boot protocol - (N)one, (B)OOTP, (D)HCP, (O)ther for $vadap{name}: ";
			$bootp = options ("n", "bdo");

			if ($bootp eq "o") {
        		print "Enter protocol name for virtual adapter $vadap{name}: ";
	    		$BOOTPROTOS{"o"} = <STDIN>;
	          chomp $BOOTPROTOS{"o"};
    	 	}

			$vadap{proto}=$BOOTPROTOS{$bootp};

			if ($bootp eq "n") {
				do {
					print "Enter ip address for virtual adapter $vadap{name}: ";
					$vadap{ipaddr}=<STDIN>;
					chomp($vadap{ipaddr});
				} while (!is_ip_addr($vadap{ipaddr}));
				do {
					print "Enter ip netmask for virtual adapter $vadap{name}: ";
					$vadap{netmask}=<STDIN>;
					chomp($vadap{netmask});
				} while (!is_ip_addr($vadap{netmask}))

			}

			$vadap{onboot}="YES";
			$vadap{agg}=$Agg{name};

			&create_if_script("ifcfg-$vadap{name}", \%vadap);
			last W2 if !($Agg{vlan} eq "y");
		}	
	
		##Show aggregator
		print "Configuration of Aggregator:\n";
		print "\nAggregator name: $Agg{name}\n";
		print "Aggregator mode: $MODES[$Agg{Mode}]\n";
		print "\nUse adapters: \n";
		foreach (@adaps) {
			print "\t$_\n";
		}
		print "\nVirtual adapters:\n";
	    while (($vname, $vid) = each(%vlans)) {
    	    print "\t$vname ";
			print "VLAN ID: $vid" if ($vid>0);
			print "\n";
	    }
    	$y="";

		while (! ($y=~"(y|Y|n|N).*")) {
			print "Are you sure ? (y/n)";
			$y=<STDIN>;
		}

		if ($y=~"(y|Y).*") {
			push @vmns_script, "CREATE AGGREGATOR $Agg{name}\n";
			push @vmns_script, "SET ATTRIBUTE MODE OF AGGREGATOR $Agg{name} TO $MODES[$Agg{Mode}]";
	
			if ($Agg{vlan} eq "y") {
				push @vmns_script, " WITH VLAN\n";
			} 
			else {
				push @vmns_script, "\n";
			}

			foreach $aname (@adaps) {
				if (!($aname eq "")) {
					enable_boot($aname,"no");
					push @vmns_script,"USE ADAPTER $aname\n";
					push @vmns_script,"ATTACH ADAPTER $aname TO $Agg{name}\n";
				}
			}

			while (($vname, $vid) = each(%vlans)) {
				push @vmns_script, "CREATE VADAPTER $vname\n";
				if ($Agg{vlan} eq "y") {
					push @vmns_script, "SET ATTRIBUTE VLAN OF VADAPTER $vname to $vid\n";
				}
				push @vmns_script, "ATTACH VADAPTER $vname to $Agg{name}\n";
			} 

			push @vmns_script,"COMMIT $Agg{name}\n";
		} else {
			splice (@Adapters, $#Adapters+1, 0, @adaps);
			`rm -f ifcfg-*`;
		}
		@adaps=();
		%vlans=();
	}

	`cp -f ifcfg-* $IFCFGDIR`;
	`rm -f ifcfg-*`;
	open OUT, ">/etc/vmns/vmns.cfg";
	print OUT @vmns_script;
	close OUT;		
	system "/usr/sbin/vmnscfg /etc/vmns/vmns.cfg >/dev/null"; 
	return 1;
}

sub vmns_remove {	
	my @interfaces;
	my $f;
	chdir $IFCFGDIR;
	@interfaces=`\\ls ifcfg* | \\grep -v '(ifcfg-lo|:)' | \\grep -v 'ifcfg-ippp[0-9]+$' | \\grep 'ifcfg-[a-z0-9]+$' | \\sed 's/^ifcfg-//g'`;

	foreach $f (@interfaces) {
		chomp($f);
		open IN, "<$IFCFGDIR/ifcfg-$f";
		WR: while (<IN>) {
			/#VMNS/ && do {
							print "Do you want to remove virtual adapter $f ?";
							if (options("y","n") eq "y") {
								system ("/sbin/ifconfig $f down");	
								system ("rm -f $IFCFGDIR/ifcfg-$f");
							}
							next WR;
						};

			`/sbin/ifconfig $f 2>&1 /dev/null`;
			enable_boot($f,"yes");
			last WR;
		}
		close IN;
	}

	foreach $l (2,3,4,5) {
		if (-f "/etc/rc.d/rc$l.d/S${STARTLEVEL}vmns") {
			`rm -f /etc/rc.d/rc$l.d/S${STARTLEVEL}vmns`;
			`rm -f /etc/rc.d/rc$l.d/K${KILLLEVEL}vmns`;
		}
	}
	`rmmod vmns 2>&1 /dev/null`;
	print "\nVMNS configuration removed successfully.\n";
}

sub install_start_script {

	print "Please select runlevels (1-5) on witch you like to load VMNS\n";
	print "(example, enter 2345) if you want to load VMNS on runlevels 2,3,4,5\n";
    print "Please select runlevels (1-5):";
	chdir($CWD);
	$runlevels=<STDIN>;

	`cp -f vmns $SCRIPTDIR/vmns`;

	while (!($runlevels=~/^\ *[1-5]+\ *$/))
	{
		print "Please select runlevels (1-5): ";
		$runlevels = <STDIN>;
	}

	chomp $runlevels;
	for ($i = "1"; $i <= "5"; $i++) {
		if ($i =~ /[$runlevels]/) {
			`ln -sf $SCRIPTDIR/vmns $LINKSDIR/rc$i.d/S${STARTLEVEL}vmns`;
			`ln -sf $SCRIPTDIR/vmns $LINKSDIR/rc$i.d/K${KILLLEVEL}vmns`;
		}
	}
	
	`cp -f vmns_down /etc/vmns`;

	print "\nDo you want to start the network now? ";
	`$SCRIPTDIR/network start` if (options("y","n") eq "y");

}

sub vmns_install {
	`insmod linuxfet 2>&1 /dev/null`;
	&get_vmns_adapters();
	chdir ($CWD);
	chdir "../..";
	system("make install");
	print "\nVMNS installed successfully.\n";
}

sub vmns_uninstall {
	&vmns_remove();
	chdir ($CWD);
	chdir "../..";
	
	`make uninstall`;
	print "VMNS uninstalled successfully.\n";
}

&main_menu;

$CWD=`pwd`;
chomp($CWD);

@Adapters=();

while (<>) {
	chomp;
	$_=2 if $_ eq "";
	SWITCH: {
		/0/	&& 	do {
					help_menu;
					last SWITCH;
				};
		/1/ && 	do {
					&vmns_install();
					last SWITCH;
				};
		/2/ &&	do {
					&vmns_remove();
					&load_module();					
					if (&setup()) {
						&install_start_script();
					}
					last SWITCH;
				};

		/3/ &&	do {
					&vmns_remove();
					last SWITCH;
				};

		/4/ &&	do {
					&vmns_uninstall();
					exit;
				};
		/5/ &&	do {
					exit;
				};

		DEFAULT: ;
	};
	&main_menu;
};
