#!/usr/bin/perl -w
$VMNSCFG="/usr/sbin/vmnscfg";
$CONF="/etc/conf.modules";
$CONF="/etc/modules.conf" unless (-e $CONF);
$VERSION=`uname -r`;
chomp $VERSION;
$IFCFGDIR="/etc/sysconfig/network-scripts";
$SCRIPTDIR="/etc/init.d";
$LINKSDIR="/etc/rc.d";
$STARTLEVEL="04";
$KILLLEVEL="41";
$MAXADAPTERS=4;
@DRVMODS=("via-rhine", "linuxfet");
@MODES=("NONE", "VLB");
%BOOTPROTOS=("n", "none", "b", "bootp", "d", "dhcp", "o", "other");

sub enable_boot
{
	 my($adapter, $onboot) = @_;
	 my(@lines);
	 return if ($onboot eq "yes");
	 $index = `cat /etc/rc.config | grep NETDEV | grep $adapter`;
	 return unless ($index =~ /NETDEV(_.)/);
	 $index = $1;
	 foreach $line (`cat /etc/rc.config`)
	 {
	     if ($line =~ /^IFCONFIG$index/) {
				push @lines, "#$line";
				push @lines, "IFCONFIG$index=\"\"\n";
	     }
		 elsif ($line =~ /^NETDEV$index/) {
				push @lines, "#$line";
				push @lines, "NETDEV$index=\"\"\n";
		 }
		 elsif ($line =~ /^IPADDR$index/) {
				push @lines, "#$line";
				push @lines, "IPADDR$index=\"\"\n";
		 }
	     else {
				push @lines, $line;
	     }
	 }
	 open (OUT, ">/etc/rc.config");
	 print OUT @lines;
	 close (OUT);
}

sub create_if_script {
	my ($devname)=shift @_;
	my ($param)=shift @_;
	my $netconfig;
	my $line;
	my @rcconfig;

	$index="";
 	$netconfig = `. ./rc.config; echo \$NETCONFIG`;
	chomp($netconfig);

	for ($i=0; $i<=$MAXADAPTERS-1; $i++) {
	     $index = "_$i" unless ($netconfig =~ /_$i/);
	}

	if ($index eq "") {
	     die "FATAL: Maximum adapters reached - cannot config another vadapter\n";
	}

	foreach $line (`cat ./rc.config`)
	 {
	     if ($line =~ /^NETCONFIG=/)
	     {
				push @rcconfig, "#$line";
				push @rcconfig, "NETCONFIG=\"$netconfig $index\"\n";
	     }
	     elsif ($line =~ /^IFCONFIG$index/)
	     {
				push @rcconfig, "IFCONFIG$index=\"$$param{ipaddr} netmask $$param{netmask}\"\n";
	     }
	     elsif ($line =~ /^IPADDR$index/)
	     {
				push @rcconfig, "IPADDR$index=\"$$param{ipaddr}\"\n";
	     }
	     elsif ($line =~ /^NETDEV$index/)
	     {
				push @rcconfig, "NETDEV$index=\"$devname\"\n";
	     }
	     else
	     {
				push @rcconfig, $line;
	     }
	 }
	open OUT, ">rc.config";
	print OUT @rcconfig;
	close OUT;		
}

sub options
{
	 my($def, $others) = @_;
	 $disp_def = $def;
	 $disp_others =  $others;
	 $disp_others =~ s/(.)/$1\//g;
	 $disp_def =~ tr/[a-z]/[A-Z]/;
	 chop ($disp_others);

	 $_ = "";
	 while (!/$\ *[$def$others]/)
	 {
		  print "([$disp_def]/$disp_others): ";
		  $_ = <STDIN>;
		  chomp;
		  tr/[A-Z]/[a-z]/;
		  $_ = $def unless ($_);
	 }
	 s/^\ *(.)*/$1/;
	 return $_;
}

sub prompt {
	my $p=shift @_;
	print $p;
	<STDIN>;
}

sub is_ip_addr
{
     my($ip)=@_;
     if ($ip=~/^([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)$/)
     {
          if ($1>255 || $2>255 || $3>255 || $4>255)
          {
                return 0;
          }
          return 1;
     }
     return 0;
}

sub is_vlan_id
{
	my ($i)=@_;

	if ($i=~/[^0-9]+/) {
		return 0;
	}

	if ($i<1 || $i>4093) {
		return 0;
	}
	return 1;
}
