
#!/usr/bin/perl -w
$VMNSCFG="/usr/sbin/vmnscfg";
$CONF="/etc/conf.modules";
$CONF="/etc/modules.conf" unless (-e $CONF);
$VERSION=`uname -r`;
chomp $VERSION;
$IFCFGDIR="/etc/sysconfig/network-scripts";
$SCRIPTDIR="/etc/rc.d/init.d";
$LINKSDIR="/etc/rc.d";
$STARTLEVEL="09";
$KILLLEVEL="91";
@DRVMODS=("via-rhine", "linuxfet");
@MODES=("NONE", "VLB");
%BOOTPROTOS=("n", "none", "b", "bootp", "d", "dhcp", "o", "other");

sub enable_boot
{
	 my($adapter, $onboot) = @_;
	 return if (!(-e "$IFCFGDIR/ifcfg-$adapter"));
	 my(@lines) = `cat $IFCFGDIR/ifcfg-$adapter`;
	 open (OUT, ">$IFCFGDIR/ifcfg-$adapter");
	 foreach $line (@lines)
	 {
		  $line =~ s/ONBOOT=.*$/ONBOOT=\"$onboot\"/;
		  print OUT $line;
	 }
	 close (OUT);
}

sub create_if_script {
	my ($scriptname)=shift @_;
	my ($param)=shift @_;

	open OUT,">$scriptname";
	print OUT <<EOF;
\#VMNS $$param{agg} VIRTUAL ADAPTER
DEVICE="$$param{name}"
BOOTPROTO="$$param{proto}"
ONBOOT="$$param{onboot}"
IPADDR="$$param{ipaddr}"
NETMASK="$$param{netmask}"
EOF
	`chmod +x $scriptname`;
	close OUT;
}

sub options
{
	 my($def, $others) = @_;
	 $disp_def = $def;
	 $disp_others =  $others;
	 $disp_others =~ s/(.)/$1\//g;
	 $disp_def =~ tr/[a-z]/[A-Z]/;
	 chop ($disp_others);

	 $_ = "";
	 while (!/$\ *[$def$others]/)
	 {
		  print "([$disp_def]/$disp_others): ";
		  $_ = <STDIN>;
		  chomp;
		  tr/[A-Z]/[a-z]/;
		  $_ = $def unless ($_);
	 }
	 s/^\ *(.)*/$1/;
	 return $_;
}

sub prompt {
	my $p=shift @_;
	print $p;
	<STDIN>;
}

sub is_ip_addr
{
     my($ip)=@_;
     if ($ip=~/^([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)$/)
     {
          if ($1>255 || $2>255 || $3>255 || $4>255)
          {
                return 0;
          }
          return 1;
     }
     return 0;
}
